﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

[System.Serializable]
public class AvatarPicker : MonoBehaviour {
	public Button[] AvatarButtons;
	public Image DisplayAvatarImage;
	public InputField nameField;
	public Text DisplayName;
	public Button nextButtion;
	private bool isAvatarPicked = false;
	private bool isScriptActive = true;
	public GameObject companyPickAreaObj;

	[HideInInspector]
	Player player;
	// Use this for initialization
	void Start () {
		player = GetComponent<Player> ();
		//companyPickAreaObj = GameObject.Find ("CompanyPickArea");
		companyPickAreaObj.gameObject.SetActive (false);
		InitButtons ();
	}
	
	// Update is called once per frame
	void Update () {
		if (isScriptActive) {
			player.playerName = nameField.text;
			DisplayName.text = player.playerName;

			if (isAvatarPicked && player.playerName.Length > 3) {
				nextButtion.gameObject.SetActive (true);
			} else {
				nextButtion.gameObject.SetActive (false);
			}
		}
	}

	public void InitButtons() {
		foreach (Button button in AvatarButtons) {
			Image img = button.transform.Find ("Image").GetComponent<Image> ();

			button.onClick.AddListener (
				delegate {
					pickAvatar (img);
				}
			);
		}

		nextButtion.onClick.AddListener (nextClick);
	}

	public void pickAvatar(Image avatarImage) {
		isAvatarPicked = true;
		DisplayAvatarImage.sprite = avatarImage.sprite;
	}

	public void nextClick() {
		GameObject.Find ("AvatarPickArea").gameObject.SetActive (false);
		//GameObject.Find ("AvatarsArea").gameObject.SetActive (false);
		//nextButtion.gameObject.SetActive (false);
		isScriptActive = false;
		companyPickAreaObj.gameObject.SetActive (true);
	}
}
