﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class BusinessPicker : MonoBehaviour {
	public GameObject buttonPrefab;
	public Button nextButton;
	[HideInInspector]
	public BusinessList businessList;
	[HideInInspector]
	public Player player;

	public bool isCompanyConfirmed = false;


	// Use this for initialization
	void Start () {
		businessList = GameObject.Find ("GameController").GetComponent<BusinessList>();
		player =  GameObject.Find ("GameController").GetComponent<Player>();
		createBusinessPickButtions ();
		nextButton.gameObject.SetActive (false);

		nextButton.onClick.AddListener (CompanyNextClick);
	}
	
	// Update is called once per frame
	void Update () {
		if (isCompanyConfirmed == false && player.business.name != "") {
			nextButton.gameObject.SetActive (true);
		}
	}

	public void createBusinessPickButtions() {
		Transform parentTransform = GameObject.Find ("CompanyPickArea/CompaniesBackground/Grid").transform;
		foreach (Business business in businessList.list) {
			GameObject obj = Instantiate (buttonPrefab) as GameObject;
			obj.transform.parent = parentTransform;
			Image img = obj.transform.Find ("ButtonWithImage/ButtonImage").GetComponent<Image> ();
			img.sprite = business.PickSprite;
			obj.name = "Button ( " + business.name + " )";
			obj.transform.Find ("Name/CompanyName").GetComponent<Text> ().text = business.name;

			Button button = obj.transform.Find ("ButtonWithImage").GetComponent<Button> ();
			button.onClick.AddListener (delegate {
				PickBusiness(business);
			});
		}
	}

	public void PickBusiness(Business business) {
		player.business = business;
	}

	public void CompanyNextClick() {
		isCompanyConfirmed = true;
		transform.gameObject.SetActive (false);
		GameObject.Find ("GameController").GetComponent<TaskManager> ().isActive = true;
	}
}
