﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class TaskManager : MonoBehaviour {

	public GameObject taskListPrefab;
	[HideInInspector]
	public Player player;
	[HideInInspector]
	public List<Task> allTasks = new List<Task>();
	//public GameObject taskObject;
	public GameObject taskPrefab;
	private GameObject currentActiveTaskObject = null;
	public Text DescriptionText;

	public Task activeTask;
	public float taskFrequenceSeconds = 5f;
	public float timeLeftToNewTask;
	public bool isActive = false;

	// Use this for initialization
	void Start () {
		Initialize ();
	}

	public void Initialize() {
		player = GetComponent<Player> ();
		LoadAllTasks ();
	}

	// Update is called once per frame
	void Update () {
		if (isActive) {
			if (currentActiveTaskObject == null && timeLeftToNewTask <= 0f) {
				showTask (getRandomTask ());
			} else {
				timeLeftToNewTask -= Time.deltaTime;
			}
		}

	}

	public void LoadAllTasks() {
		//GameObject taskListObj = Instantiate (taskListPrefab);
		//TaskList taskList = taskListObj.GetComponent<TaskList> ();

		TaskList taskList = new TaskList();
		taskList.createTasks ();
		foreach (Task task in taskList.tasks) {
			for (int i = 0; i < task.probabilityCount; i++) {
				allTasks.Add (task);
			}
		}
	}

	public Task getRandomTask() {
		if (allTasks.Count > 0) {
			int randomTaskIndex = Random.Range (0, allTasks.Count);
			return allTasks [randomTaskIndex];
		} else {
			return null;
		}
	}

	public void showTask(Task task) {
		timeLeftToNewTask = taskFrequenceSeconds;
		activeTask = task;

		currentActiveTaskObject = Instantiate (taskPrefab, GameObject.Find ("PersonalTasks").gameObject.transform, false);
		currentActiveTaskObject.name = "Task";
		currentActiveTaskObject.transform.Find ("Description/Text").GetComponent<Text> ().text = task.description;
		Button[] optionButtons = new Button [3];
		Button currentButton;
		for (int i = 0; i < 3; i++) {
			currentButton = currentActiveTaskObject.transform.Find ("Buttons/Grid/TaskButton" + i.ToString ()).GetComponent<Button> ();
			optionButtons [i] = currentButton;
			currentButton.gameObject.SetActive (false);
		}

		int ii = 0;
		foreach (Task.TaskOption option in task.taskOptions) {
			currentButton = optionButtons[ii];
			currentButton.transform.Find ("DescriptionText").GetComponent<Text> ().text = option.description;
			currentButton.transform.Find ("ValueText").GetComponent<Text> ().text = option.taskValue.ToString();
			currentButton.gameObject.SetActive (true);
			currentButton.onClick.AddListener (delegate {
				pickOption(option);
			});
			ii++;
		}
	}

	public void pickOption(Task.TaskOption option) {
		player.currentBalance += option.taskValue;
		Destroy (currentActiveTaskObject);
	}


}
